unit UMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  dglOpenGL, UGFX, StdCtrls, ExtCtrls, Contnrs, ComCtrls;

const
  NearClipping       = 1;
  FarClipping        = 1000;

  GL_CMD_NONE        = 0;
  GL_CMD_TRANSLATE   = 1;
  GL_CMD_ROTATE      = 2;
  GL_CMD_SCALE       = 3;

type
  TScriptElement = class;

  TForm1 = class(TForm)
    Panel3: TPanel;
    GroupBox1: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    Label6: TLabel;
    ListBox1: TListBox;
    Panel2: TPanel;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    BtnAddCmd: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    BtnInsCmd: TButton;
    BtnClrUnder: TButton;
    BtnClrOver: TButton;
    BtnClrAct: TButton;
    Edit5: TEdit;
    UpDown1: TUpDown;
    Edit6: TEdit;
    Edit7: TEdit;
    GroupBox3: TGroupBox;
    Panel1: TPanel;
    CheckBox1: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure IdleHandler(Sender: TObject; var Done: Boolean);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BtnAddCmdClick(Sender: TObject);
    procedure UpDown1ChangingEx(Sender: TObject; var AllowChange: Boolean;
      NewValue: Smallint; Direction: TUpDownDirection);
    procedure BtnInsCmdClick(Sender: TObject);
    procedure Edit5Change(Sender: TObject);
    procedure BtnClrUnderClick(Sender: TObject);
    procedure BtnClrOverClick(Sender: TObject);
    procedure BtnClrActClick(Sender: TObject);
  private
    { Private-Deklarationen }
    StartTime, TimeCount, FrameCount  : Cardinal; //FrameCounter
    Frames, DrawTime                  : Cardinal; //& Timebased Movement
    GLError                           : Cardinal;
    procedure SetupGL;
    procedure Init;
    procedure Render;
    procedure ErrorHandler;
    procedure SetCommand(cmd : integer);
    procedure AddCommand(cmd : TScriptElement);
    procedure InsertCommand(cmd : TScriptElement);
    function CmdToStr(cmd : integer) : string;
  public
    { Public-Deklarationen }
    DC                                : HDC;  //Handle auf Zeichenflche
    RC                                : HGLRC;//Rendering Context
    Step                              : Integer; // Zeigt an, bis zu welchem Befehl im Script gerendert werden soll
  end;

  TScript = class(TObjectList)
    private

    public
      procedure Add(AObject : TObject); reintroduce;
      procedure Insert(Index : integer; AObject : TObject); reintroduce;
      procedure Delete(Index : integer); reintroduce;
      procedure DeleteAllAfter(Index : integer);
      procedure DeleteAllBefore(Index : integer);
  end;

  TScriptElement = class
    private
       cmd : integer;
         x : TGLfloat;
         y : TGLfloat;
         z : TGLfloat;
         w : TGLfloat;
    public
      constructor Create; overload;
      constructor Create(cmd : integer; X,Y,Z,W : TGLfloat); overload;
      destructor Destroy; override;
      procedure Call;
  end;

var
  Form1 : TForm1;
  aGrid : TGrid;
  Script: TScript;

implementation

{$R *.DFM}

procedure TScript.Add(AObject : TObject);
var cmd : TScriptElement;
begin
     inherited Add(AObject);
     Form1.UpDown1.Max := self.Count-1;

     cmd := TScriptElement(AObject);
     if (cmd.cmd = GL_CMD_TRANSLATE)or
        (cmd.cmd = GL_CMD_SCALE)
        then Form1.ListBox1.Items.Add(Form1.CmdToStr(cmd.cmd)+'('+
                                      stringReplace( FloatToStrF(cmd.x,ffFixed,7,1) ,',','.',[rfReplaceAll])+', '+
                                      stringReplace( FloatToStrF(cmd.y,ffFixed,7,1) ,',','.',[rfReplaceAll])+', '+
                                      stringReplace( FloatToStrF(cmd.z,ffFixed,7,1) ,',','.',[rfReplaceAll])+');') else
     if (cmd.cmd = GL_CMD_ROTATE)
        then Form1.ListBox1.Items.Add(Form1.CmdToStr(cmd.cmd)+'('+
                                      stringReplace( FloatToStrF(cmd.w,ffFixed,7,1) ,',','.',[rfReplaceAll])+', '+
                                      stringReplace( FloatToStrF(cmd.x,ffFixed,7,1) ,',','.',[rfReplaceAll])+', '+
                                      stringReplace( FloatToStrF(cmd.y,ffFixed,7,1) ,',','.',[rfReplaceAll])+', '+
                                      stringReplace( FloatToStrF(cmd.z,ffFixed,7,1) ,',','.',[rfReplaceAll])+');');

end;
procedure TScript.Insert(Index : integer; AObject : TObject);
var cmd : TScriptElement;
begin
     inherited Insert(index, AObject);
     Form1.UpDown1.Max := self.Count-1;

     cmd := TScriptElement(AObject);
     if (cmd.cmd = GL_CMD_TRANSLATE)or
        (cmd.cmd = GL_CMD_SCALE)
        then Form1.ListBox1.Items.Insert(index, Form1.CmdToStr(cmd.cmd)+'('+
                                                stringReplace( FloatToStrF(cmd.x,ffFixed,7,1) ,',','.',[rfReplaceAll])+', '+
                                                stringReplace( FloatToStrF(cmd.y,ffFixed,7,1) ,',','.',[rfReplaceAll])+', '+
                                                stringReplace( FloatToStrF(cmd.z,ffFixed,7,1) ,',','.',[rfReplaceAll])+');') else
     if (cmd.cmd = GL_CMD_ROTATE)
        then Form1.ListBox1.Items.Insert(index, Form1.CmdToStr(cmd.cmd)+'('+
                                                stringReplace( FloatToStrF(cmd.w,ffFixed,7,1) ,',','.',[rfReplaceAll])+', '+
                                                stringReplace( FloatToStrF(cmd.x,ffFixed,7,1) ,',','.',[rfReplaceAll])+', '+
                                                stringReplace( FloatToStrF(cmd.y,ffFixed,7,1) ,',','.',[rfReplaceAll])+', '+
                                                stringReplace( FloatToStrF(cmd.z,ffFixed,7,1) ,',','.',[rfReplaceAll])+');');
end;
procedure TScript.Delete(Index : integer);
begin
     if index = -1 then exit;
     
     inherited Delete(Index);
     Form1.UpDown1.Max := self.Count-1;
     if Form1.Step > Form1.UpDown1.Max then Form1.Step := Form1.UpDown1.Max;
     Form1.ListBox1.Items.Delete(Index);
end;
procedure TScript.DeleteAllAfter(Index : integer);
begin
     while Index < self.count-1 do
           self.Delete(Index+1);
     Form1.UpDown1.Max := self.Count-1;
     if Form1.Step > self.Count-1 then Form1.Step := self.Count-1;
     if Form1.Step > Form1.UpDown1.Max then Form1.Step := Form1.UpDown1.Max;
end;
procedure TScript.DeleteAllBefore(Index : integer);
var i : integer;
begin
     for i := 1 to index do
         self.Delete(0);
     Form1.UpDown1.Max := self.Count-1;
     Form1.Step := 0;
end;

constructor TScriptElement.Create;
begin
     inherited;
end;
constructor TScriptElement.Create(cmd : integer; X,Y,Z,W : TGLfloat);
begin
     inherited Create;
     self.cmd  := cmd;
     self.x    := X;
     self.y    := Y;
     self.z    := Z;
     self.w    := W;
end;
destructor TScriptElement.Destroy;
begin
     inherited;
end;
procedure TScriptElement.Call;
begin
     case cmd of GL_CMD_NONE      : ;
                 GL_CMD_TRANSLATE : glTranslatef(x,y,z);
                 GL_CMD_ROTATE    : glRotatef(w,x,y,z);
                 GL_CMD_SCALE     : glScalef(x,y,z);
     end;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  if not InitOpenGL then Application.Terminate;

  DC:= GetDC(Panel1.Handle);
  Application.OnIdle:= IdleHandler;
  RC:= CreateRenderingContext( DC,
                               [opDoubleBuffered],
                               32,
                               24,
                               0,0,0,
                               0);
  ActivateRenderingContext(DC, RC);

  SetupGL;
  Init;
end;

procedure TForm1.SetupGL;
begin
  glClearColor(1.0, 1.0, 1.0, 0.0); //Hintergrundfarbe
  glEnable(GL_DEPTH_TEST);          //Tiefenpuffer aktivieren
  glEnable(GL_CULL_FACE);           //Backface Culling aktivieren
end;

procedure TForm1.Init;
begin
  GLError             := GL_NO_ERROR;
  Step                := -1;
  aGrid               := TGrid.Create;
  Script              := TScript.Create;
  Script.OwnsObjects  := true;
  SetCommand(GL_CMD_NONE);
end;

procedure TForm1.IdleHandler(Sender: TObject; var Done: Boolean);
begin
//
  StartTime:= GetTickCount;

  Render;

  DrawTime:= GetTickCount - StartTime;

  inc(TimeCount, DrawTime);
  inc(FrameCount);

  if TimeCount >= 1000 then begin
    Frames:= FrameCount;
    TimeCount:= TimeCount - 1000;
    FrameCount:= 0;

    Caption:= InttoStr(Frames) + 'FPS';
    ErrorHandler;
  end;

  Done:= false;
end;

procedure TForm1.Render;
var i : integer;
begin
//
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
  gluPerspective(45.0, Panel1.Width/Panel1.Height, NearClipping, FarClipping);

  glTranslatef(0, 0, -15);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity;

  glRotatef(30,1,0,0);
  glRotatef(30,0,1,0);

  if CheckBox1.Checked then
     begin
          aGrid.Active := false;
          aGrid.drawGrid; //Zustand nach glLoadIdentity
     end;

  for i := 0 to Step do
      begin
           TScriptElement(Script[i]).Call;
           if CheckBox1.Checked then aGrid.drawGrid;
      end;
  aGrid.Active := true;
  aGrid.drawGrid;

  SwapBuffers(DC);
end;

procedure TForm1.ErrorHandler;
begin
  GLError := glGetError;
  if GLError <> GL_NO_ERROR then
     Caption := gluErrorString(GLError);

end;

procedure TForm1.FormResize(Sender: TObject);
var tmpBool : Boolean;
begin
  glViewport(0, 0, Panel1.Width, Panel1.Height);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
  gluPerspective(45.0, Panel1.Width/Panel1.Height, NearClipping, FarClipping);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity;
  IdleHandler(Sender, tmpBool);
end;

procedure TForm1.FormDestroy(Sender: TObject);
var i : integer;
begin
  DeactivateRenderingContext;
  DestroyRenderingContext(RC);
  ReleaseDC(Handle, DC);

  aGrid.Free;
  Script.Free;
end;

function TForm1.CmdToStr(cmd : integer) : string;
begin
     case cmd of GL_CMD_NONE: result := '!!KeinGltigerBefehl!!';
           GL_CMD_TRANSLATE : result := 'glTranslatef';
              GL_CMD_ROTATE : result := 'glRotatef';
               GL_CMD_SCALE : result := 'glScalef';
     end;
end;

procedure TForm1.SetCommand(cmd : integer);
begin
     BtnAddCmd.Enabled    := true;
     BtnInsCmd.Enabled    := true;

     case cmd of GL_CMD_NONE: begin
                                   RadioButton1.Checked := false;
                                   RadioButton2.Checked := false;
                                   RadioButton3.Checked := false;

                                   Edit1.Enabled        := false;  Edit1.Text   := '0';
                                   Edit2.Enabled        := false;  Edit2.Text   := '0';
                                   Edit3.Enabled        := false;  Edit3.Text   := '0';
                                   Edit4.Enabled        := false;  Edit4.Text   := '0';

                                   BtnAddCmd.Enabled    := false;
                                   BtnInsCmd.Enabled    := false;
                              end;
            GL_CMD_TRANSLATE: begin
                                   RadioButton1.Checked := true;
                                   RadioButton2.Checked := false;
                                   RadioButton3.Checked := false;

                                   Edit1.Enabled        := true;
                                   Edit2.Enabled        := true;
                                   Edit3.Enabled        := true;
                                   Edit4.Enabled        := false;
                              end;
               GL_CMD_ROTATE: begin
                                   RadioButton1.Checked := false;
                                   RadioButton2.Checked := true;
                                   RadioButton3.Checked := false;

                                   Edit1.Enabled        := true;
                                   Edit2.Enabled        := true;
                                   Edit3.Enabled        := true;
                                   Edit4.Enabled        := true;
                              end;
                GL_CMD_SCALE: begin
                                   RadioButton1.Checked := false;
                                   RadioButton2.Checked := false;
                                   RadioButton3.Checked := true;

                                   Edit1.Enabled        := true;
                                   Edit2.Enabled        := true;
                                   Edit3.Enabled        := true;
                                   Edit4.Enabled        := false;
                              end;
     end;
end;

procedure TForm1.RadioButton1Click(Sender: TObject);
begin
     if Sender = RadioButton1 then
        begin
             SetCommand(GL_CMD_TRANSLATE);
        end else
     if Sender = RadioButton2 then
        begin
             SetCommand(GL_CMD_ROTATE);
        end else
     if Sender = RadioButton3 then
        begin
             SetCommand(GL_CMD_SCALE);
        end;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     case Key of VK_UP: begin
                             if Step > 0 then dec(Step);
                        end;
               VK_DOWN: begin
                             if Step < ListBox1.Items.Count-1 then inc(Step);
                        end;
     end;
end;

procedure TForm1.AddCommand(cmd : TScriptElement);
begin
     Script.Add(cmd);
end;
procedure TForm1.InsertCommand(cmd : TScriptElement);
var p : integer;
begin
     p := Form1.UpDown1.Position+1;
     Script.Insert(p, cmd);
end;

procedure TForm1.BtnAddCmdClick(Sender: TObject);
var newCmd : TScriptElement;
    cmd    : integer;
    x,y,z,w: real;
begin
     if RadioButton1.Checked then cmd := GL_CMD_TRANSLATE else
     if RadioButton2.Checked then cmd := GL_CMD_ROTATE else
     if RadioButton3.Checked then cmd := GL_CMD_SCALE else
                                  cmd := GL_CMD_NONE;

     try
        x := StrToFloat(stringReplace(Edit1.Text,'.',',',[rfReplaceAll]));
        y := StrToFloat(stringReplace(Edit2.Text,'.',',',[rfReplaceAll]));
        z := StrToFloat(stringReplace(Edit3.Text,'.',',',[rfReplaceAll]));
        w := StrToFloat(stringReplace(Edit4.Text,'.',',',[rfReplaceAll]));
     except
           ShowMessage('Fehler beim auslesen der Parameter!');
           exit;
     end;


     AddCommand( TScriptElement.Create(cmd,x,y,z,w) );


end;

procedure TForm1.BtnInsCmdClick(Sender: TObject);
var newCmd : TScriptElement;
    cmd    : integer;
    x,y,z,w: real;
begin
     if RadioButton1.Checked then cmd := GL_CMD_TRANSLATE else
     if RadioButton2.Checked then cmd := GL_CMD_ROTATE else
     if RadioButton3.Checked then cmd := GL_CMD_SCALE else
                                  cmd := GL_CMD_NONE;

     try
        x := StrToFloat(stringReplace(Edit1.Text,'.',',',[rfReplaceAll]));
        y := StrToFloat(stringReplace(Edit2.Text,'.',',',[rfReplaceAll]));
        z := StrToFloat(stringReplace(Edit3.Text,'.',',',[rfReplaceAll]));
        w := StrToFloat(stringReplace(Edit4.Text,'.',',',[rfReplaceAll]));
     except
           ShowMessage('Fehler beim auslesen der Parameter!');
           exit;
     end;


     InsertCommand( TScriptElement.Create(cmd,x,y,z,w) );
end;

procedure TForm1.UpDown1ChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: Smallint;
  Direction: TUpDownDirection);
begin
     if NewValue <= UpDown1.Max then Step := NewValue;
end;

procedure TForm1.Edit5Change(Sender: TObject);
begin
     case UpDown1.Position of -1: Label7.Caption := 'glLoadIdentity';
                             else Label7.Caption := ListBox1.Items[UpDown1.Position];
     end;
end;

procedure TForm1.BtnClrUnderClick(Sender: TObject);
begin
     Script.DeleteAllAfter(Step);
end;

procedure TForm1.BtnClrOverClick(Sender: TObject);
begin
     Script.DeleteAllBefore(Step);
end;

procedure TForm1.BtnClrActClick(Sender: TObject);
begin
     Script.Delete(Step);
end;

end.

